// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package fakerapp

import (
	context "context"
	httpbody "google.golang.org/genproto/googleapis/api/httpbody"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// FakeSvcClient is the client API for FakeSvc service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type FakeSvcClient interface {
	//LivenessProbe for the service
	HealthCheck(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*httpbody.HttpBody, error)
	//ReadinessProbe for the service
	ReadyCheck(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*httpbody.HttpBody, error)
	Echo(ctx context.Context, in *EchoRequest, opts ...grpc.CallOption) (*EchoResponse, error)
	Error(ctx context.Context, in *EchoRequest, opts ...grpc.CallOption) (*EchoResponse, error)
}

type fakeSvcClient struct {
	cc grpc.ClientConnInterface
}

func NewFakeSvcClient(cc grpc.ClientConnInterface) FakeSvcClient {
	return &fakeSvcClient{cc}
}

func (c *fakeSvcClient) HealthCheck(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*httpbody.HttpBody, error) {
	out := new(httpbody.HttpBody)
	err := c.cc.Invoke(ctx, "/com.gitlab.nishanth.shettynetbook.FakeSvc/HealthCheck", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *fakeSvcClient) ReadyCheck(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*httpbody.HttpBody, error) {
	out := new(httpbody.HttpBody)
	err := c.cc.Invoke(ctx, "/com.gitlab.nishanth.shettynetbook.FakeSvc/ReadyCheck", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *fakeSvcClient) Echo(ctx context.Context, in *EchoRequest, opts ...grpc.CallOption) (*EchoResponse, error) {
	out := new(EchoResponse)
	err := c.cc.Invoke(ctx, "/com.gitlab.nishanth.shettynetbook.FakeSvc/Echo", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *fakeSvcClient) Error(ctx context.Context, in *EchoRequest, opts ...grpc.CallOption) (*EchoResponse, error) {
	out := new(EchoResponse)
	err := c.cc.Invoke(ctx, "/com.gitlab.nishanth.shettynetbook.FakeSvc/Error", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// FakeSvcServer is the server API for FakeSvc service.
// All implementations should embed UnimplementedFakeSvcServer
// for forward compatibility
type FakeSvcServer interface {
	//LivenessProbe for the service
	HealthCheck(context.Context, *emptypb.Empty) (*httpbody.HttpBody, error)
	//ReadinessProbe for the service
	ReadyCheck(context.Context, *emptypb.Empty) (*httpbody.HttpBody, error)
	Echo(context.Context, *EchoRequest) (*EchoResponse, error)
	Error(context.Context, *EchoRequest) (*EchoResponse, error)
}

// UnimplementedFakeSvcServer should be embedded to have forward compatible implementations.
type UnimplementedFakeSvcServer struct {
}

func (UnimplementedFakeSvcServer) HealthCheck(context.Context, *emptypb.Empty) (*httpbody.HttpBody, error) {
	return nil, status.Errorf(codes.Unimplemented, "method HealthCheck not implemented")
}
func (UnimplementedFakeSvcServer) ReadyCheck(context.Context, *emptypb.Empty) (*httpbody.HttpBody, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ReadyCheck not implemented")
}
func (UnimplementedFakeSvcServer) Echo(context.Context, *EchoRequest) (*EchoResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Echo not implemented")
}
func (UnimplementedFakeSvcServer) Error(context.Context, *EchoRequest) (*EchoResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Error not implemented")
}

// UnsafeFakeSvcServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to FakeSvcServer will
// result in compilation errors.
type UnsafeFakeSvcServer interface {
	mustEmbedUnimplementedFakeSvcServer()
}

func RegisterFakeSvcServer(s grpc.ServiceRegistrar, srv FakeSvcServer) {
	s.RegisterService(&FakeSvc_ServiceDesc, srv)
}

func _FakeSvc_HealthCheck_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FakeSvcServer).HealthCheck(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.gitlab.nishanth.shettynetbook.FakeSvc/HealthCheck",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FakeSvcServer).HealthCheck(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _FakeSvc_ReadyCheck_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FakeSvcServer).ReadyCheck(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.gitlab.nishanth.shettynetbook.FakeSvc/ReadyCheck",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FakeSvcServer).ReadyCheck(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _FakeSvc_Echo_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(EchoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FakeSvcServer).Echo(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.gitlab.nishanth.shettynetbook.FakeSvc/Echo",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FakeSvcServer).Echo(ctx, req.(*EchoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _FakeSvc_Error_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(EchoRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(FakeSvcServer).Error(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.gitlab.nishanth.shettynetbook.FakeSvc/Error",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(FakeSvcServer).Error(ctx, req.(*EchoRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// FakeSvc_ServiceDesc is the grpc.ServiceDesc for FakeSvc service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var FakeSvc_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.gitlab.nishanth.shettynetbook.FakeSvc",
	HandlerType: (*FakeSvcServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "HealthCheck",
			Handler:    _FakeSvc_HealthCheck_Handler,
		},
		{
			MethodName: "ReadyCheck",
			Handler:    _FakeSvc_ReadyCheck_Handler,
		},
		{
			MethodName: "Echo",
			Handler:    _FakeSvc_Echo_Handler,
		},
		{
			MethodName: "Error",
			Handler:    _FakeSvc_Error_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "fakerapp.proto",
}
